/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/10 10:10:06
 */
import { Component } from 'wkit'
import { createWebHashHistory, createWebHistory } from './router-engine.js'
import './router-components.js'

export { createWebHashHistory, createWebHistory }

export function createRouter({
  history = createWebHashHistory(),
  routes = []
} = {}) {
  let $router = history()

  window.__wkitd__.set('$router', $router)

  $router.addRoute(routes)
  function wrapper() {
    Component.prototype.$router = $router
  }
  wrapper.beforeEach = $router.beforeEach.bind($router)
  return wrapper
}

export function getRouter() {
  return window.__wkitd__.get('$router')
}

export function getCurrentPage() {
  return getRouter().route
}
